//=============================================================================

#include "hellolib.hpp"
using namespace std;

//-----------------------------------------------------------------------------

string readUserName(istream& in, ostream& out)
{
   for (;;)
   {
      out << "Name: ";
      string name;
      getline(in, name);
      if (!name.empty())
      {
         return name;
      }
      out << "Nicht nichts\n";
   }
}

void hello(ostream& out, string_view name)
{
   const string::size_type starwidth = 11 + name.length();
   const string stars(starwidth, '*');

   const string::size_type spacewidth = starwidth - 2;
   const string spaces(spacewidth, ' ');

   out << stars << "\n"
      <<'*' << spaces << "*\n"
      << "* Hallo " << name << "! *\n"
      << '*' << spaces << "*\n"
      << stars << '\n';
}

void mymain(istream& in, ostream& out)
{
   string name = readUserName(in, out);
   out << '\n';
   hello(out, name);
}
